/*
 * MemInfo.java
 *
 * Created on July 20, 2003, 1:39 AM
 */

package net.corefandango.sysinfo;

/**
 *
 * @author Davide Savazzi
 */
public class MemInfo {
    
    public MemInfo(long totalSize, long freeSize) {
        total.set(totalSize);
        free.set(freeSize);
        used.set(totalSize - freeSize);
        usedPercentage.set((used.get() * 100F) / totalSize);
    }
    
    /** 
     * Memoria totale.
     */
    public ByteSize getTotal() {
        return total;
    }    
    
    /** 
     * Memoria libera.
     */
    public ByteSize getFree() {
        return free;
    }

    /**
     * Memoria utilizzata.
     */
    public ByteSize getUsed() {
        return used;
    }
    
    /**
     * Percentuale di memoria utilizzata.
     */
    public Percentage getUsedPercentage() {
        return usedPercentage;
    }
    
    
    private ByteSize total = new ByteSize();
    private ByteSize free = new ByteSize();
    private ByteSize used = new ByteSize();
    private Percentage usedPercentage = new Percentage();
}

