/*
 * Meminfo.java
 *
 * Created on July 4, 2003, 10:55 PM
 */

package net.corefandango.sysinfo;

import java.util.*;
import java.io.*;


/**
 *
 * @author Davide Savazzi
 */
public class MemInfoReader {
    
    /** Creates a new instance of Meminfo */
    public MemInfoReader() throws IOException {
        read();
    }
    
    public MemInfo getPhysicalMemory() {
        return physicalMemory;
    }    
    
    public MemInfo getDiskSwap() {
        return diskSwap;
    }
        
    public MemInfo getVmMemory() {
        return vmMemory;
    }
    
    protected void read() throws IOException
    {    
        vmMemory = new MemInfo(
            Runtime.getRuntime().totalMemory(), 
            Runtime.getRuntime().freeMemory());
        
        LineNumberReader reader = new LineNumberReader(
            new InputStreamReader(new FileInputStream("/proc/meminfo")));
        
        String line = reader.readLine();
        while (line != null) {
            String[] tokens = split(line, " ");
            if (tokens[0].equals("Mem:")) {
                physicalMemory = new MemInfo(
                    Long.parseLong(tokens[1]), 
                    Long.parseLong(tokens[3]));
            } else if (tokens[0].equals("Swap:")) {
                diskSwap = new MemInfo(
                    Long.parseLong(tokens[1]),
                    Long.parseLong(tokens[3])); 
            }
            line = reader.readLine();
        }        
    }
    
    protected static String[] split(String aString, String delimiter) {
        StringTokenizer tokenizer = new StringTokenizer(aString, delimiter);
        List tokens = new ArrayList(); 
        while (tokenizer.hasMoreTokens()) {
            tokens.add(tokenizer.nextToken());
        }
        String[] result = new String[tokens.size()];
        return (String[]) tokens.toArray(result);
    }

    
    protected MemInfo physicalMemory;
    protected MemInfo diskSwap;
    protected MemInfo vmMemory;

}
